# Python imports
import os

# Lib imports
import gi
gi.require_version('Gtk', '3.0')
from gi.repository import Gtk

# Application imports
from .controller_data import ControllerData
from .containers.base_container import BaseContainer



class Controller(ControllerData):
    def __init__(self, args, unknownargs):
        self.setup_controller_data()

        self._setup_styling()
        self._setup_signals()
        self._subscribe_to_events()


    def _setup_styling(self):
        ...

    def _setup_signals(self):
        ...

    def _subscribe_to_events(self):
        event_system.subscribe("tggl_top_main_menubar", self._tggl_top_main_menubar)

    def _tggl_top_main_menubar(self):
        logger.debug("_tggl_top_main_menubar > stub...")

    def setup_builder_and_container(self):
        self.builder = Gtk.Builder()
        settings.set_builder(self.builder)
        self.base_container = BaseContainer()

        settings.register_signals_to_builder([self, self.base_container])

    def get_base_container(self):
        return self.base_container
